local Mockingbird = ...

---------------------------------
--| Register Materials |smoke fire spark
--------------------------
Mockingbird:registerAssetId("models/fire.png", "FIRE_TEXTURE")
Mockingbird:registerAssetId("models/smoke.png", "SMOKE_TEXTURE")
Mockingbird:registerAssetId("models/spark.png", "SPARK_TEXTURE")
Mockingbird:registerAssetId("models/candle.png", "CANDLE_TEXTURE")
Mockingbird:registerAssetId("models/smoke_pink.png", "SMOKEPINK_TEXTURE")



--WATER
Mockingbird:registerAssetId("models/markets.fbx/Materials/water", "WATER_TUB_MATERIAL")
Mockingbird:registerAssetId("models/mockingbird.fbx/Materials/water", "WATER_BARREL_MATERIAL")
Mockingbird:override({
    Id = "WATER_TUB_MATERIAL",
	HasTransparency = true,
    IsLighted = false
})
Mockingbird:override({
    Id = "WATER_BARREL_MATERIAL",
	HasTransparency = true,
    IsLighted = false
})


--CAMPFIRE and CANDLES


Mockingbird:register({
	DataType = "MATERIAL",
	Id = "LAMP_MATERIAL",
	AlbedoTexture = "SMOKEPINK_TEXTURE"
})

Mockingbird:register({
	DataType = "MATERIAL",
	Id = "CANDLE_MATERIAL",
	AlbedoTexture = "CANDLE_TEXTURE"
})

Mockingbird:register({
	DataType = "MATERIAL",
	Id = "FIRE_MATERIAL",
	AlbedoTexture = "FIRE_TEXTURE"
})

Mockingbird:register({
	DataType = "MATERIAL",
	Id = "SMOKE_MATERIAL",
	AlbedoTexture = "SMOKE_TEXTURE"
})
Mockingbird:register({
	DataType = "MATERIAL",
	Id = "SPARK_MATERIAL",
	AlbedoTexture = "SPARK_TEXTURE"
})



---------------------------------
--| Register Particle Systems |--
---------------------------------
--lamp
Mockingbird:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "SMOKEPINK_PARTICLE_SYSTEM",
	Material = "LAMP_MATERIAL",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 8, --was5
	Looping = true,
	Delay = { 2, 2 },
	LifeTime = 3,
	StartSpeed = { 0.3, 0.3 },
    StartSize = { 1.5, 1.5 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = 0,
	RateOverTime = 2,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.1,
		Radius = 0.0001,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.05, 0, 0.05 },
		ValueB = { -0.05, 0, -0.05 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 0 },
			{ T = 0.2, Alpha = 20 },
			{ T = 0.4, Alpha = 30 },
			{ T = 0.6, Alpha = 40 },
			{ T = 0.7, Alpha = 80 },
			{ T = 0.8, Alpha = 30 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0.1, Value = 0.2 },
			{ T = 0.5, Value = 0.3 },
			{ T = 1, Value = 0.5 }
	},
	RotationOverLifetime = { -25, 25 }
})
Mockingbird:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "FIRE_PARTICLE_SYSTEM",
	Material = "FIRE_MATERIAL",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 1.5,
	Looping = true,
	Delay = { 0, 0 },
	LifeTime = 1.8,
	StartSpeed = { 0.3, 0.3 },
	StartSize = { 3.7, 3.7 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = -0.001,
	RateOverTime = 15,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.1,
		Radius = 0.0001,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.1, 0, 0.1 },
		ValueB = { -0.1, 0, -0.1 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 10 },
			{ T = 0.2, Alpha = 90 },
			{ T = 0.3, Alpha = 0 },
			{ T = 0.4, Alpha = 0 },
			{ T = 0.5, Alpha = 90 },
			{ T = 0.6, Alpha = 0 },
			{ T = 0.7, Alpha = 40 },
			{ T = 0.8, Alpha = 20 },
			{ T = 0.9, Alpha = 10 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0, Value = 0.1 },
			{ T = 0.5, Value = 0.2 },
			{ T = 1, Value = 0.3 }
	},
	RotationOverLifetime = { -70, 70 }
})

Mockingbird:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "SMOKE_PARTICLE_SYSTEM",
	Material = "SMOKE_MATERIAL",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 5,
	Looping = true,
	Delay = { 0, 0 },
	LifeTime = 4,
	StartSpeed = { 0.3, 0.3 },
	StartSize = { 2.5, 2.5 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = 0,
	RateOverTime = 2,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.1,
		Radius = 0.0001,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.05, 0, 0.05 },
		ValueB = { -0.05, 0, -0.05 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 0 },
			{ T = 0.2, Alpha = 20 },
			{ T = 0.4, Alpha = 30 },
			{ T = 0.6, Alpha = 40 },
			{ T = 0.7, Alpha = 80 },
			{ T = 0.8, Alpha = 30 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0.1, Value = 0.2 },
			{ T = 0.5, Value = 0.3 },
			{ T = 1, Value = 0.5 }
	},
	RotationOverLifetime = { -25, 25 }
})

Mockingbird:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "SPARK_PARTICLE_SYSTEM",
	Material = "SPARK_MATERIAL",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 2,
	Looping = true,
	Delay = { 0, 1 },
	LifeTime = 1.7,
	StartSpeed = { 0.005, 0.005 },
	StartSize = { 0.5, 0.5 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = -0.2,
	RateOverTime = 4,
	RateOverTimeRandom = 6,
	AlignWithVelocity = true,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 2,
		Radius = 0.1
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.5, -0.1, 0.5 },
		ValueB = { -0.5, -0.1, -0.5 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.6, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.6, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 1 } }
		},		
		AlphaList = {
			{ T = 0.1, Alpha = 100 },
			{ T = 0.3, Alpha = 100 },
			{ T = 0.5, Alpha = 50 },
			{ T = 0.7, Alpha = 25 },
			{ T = 1, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0, Value = 0.075 },
			{ T = 0.5, Value = 0.050 },
			{ T = 1, Value = 0.025 }
	},
	RotationOverLifetime = { -50, 50 }
})

Mockingbird:register({
	DataType = "PARTICLE_SYSTEM",
	Id = "CANDLE_PARTICLE_SYSTEM",
	Material = "CANDLE_MATERIAL",
	BillboardBehavior = "FACE_CAMERA",
	Duration = 1,
	Looping = true,
	Delay = { 0, 0 },
	LifeTime = 0.5,
	StartSpeed = { 0.01, 0.01 },
	StartSize = { 0.4, 0.4 },
	StartRotation = { 0, 0 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = 0,
	RateOverTime = 10,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 3,
		Radius = 0.01
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT",
		Value = { 0, 0, 0 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.6, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.6, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 1 } }
		},
		AlphaList = {
			{ T = 0, Alpha = 0 },
			{ T = 0.1, Alpha = 100 },
			{ T = 0.2, Alpha = 75 },
			{ T = 1, Alpha = 50 }
		},
	},
	SizeOverLifetime = {
			{ T = 0, Value = 0.1 },
			{ T = 0.5, Value = 0.2 },
			{ T = 0.8, Value = 0.2 }
	},
	RotationOverLifetime = { 0, 0 },
})


------------------------------------
--| Register Particle Components |--
------------------------------------
--lamp
Mockingbird:registerPrefabComponent("models/mockingbird.fbx/Prefab/Alamp_Part/LampEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "SMOKEPINK_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})

Mockingbird:registerPrefabComponent("models/markets.fbx/Prefab/Astew_Part/FireEmitter1", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "FIRE_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
Mockingbird:registerPrefabComponent("models/markets.fbx/Prefab/Astew_Part/FireEmitter2", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "FIRE_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
Mockingbird:registerPrefabComponent("models/markets.fbx/Prefab/Astew_Part/SmokeEmitter1", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "SMOKE_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
Mockingbird:registerPrefabComponent("models/markets.fbx/Prefab/Astew_Part/SparkEmitter1-1", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "SPARK_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
Mockingbird:registerPrefabComponent("models/markets.fbx/Prefab/Astew_Part/SparkEmitter1-2", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "SPARK_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
Mockingbird:registerPrefabComponent("models/mockingbird.fbx/Prefab/Afortune_Part/CandleEmitter19", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "CANDLE_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
Mockingbird:registerPrefabComponent("models/mockingbird.fbx/Prefab/Afortune_Part/CandleEmitter20", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "CANDLE_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})
Mockingbird:registerPrefabComponent("models/mockingbird.fbx/Prefab/Afortune_Part/CandleEmitter21", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "CANDLE_PARTICLE_SYSTEM",
	IsPlaying = true,
	IsEmitting = true
})